MacOSX: many warnings with compiler CLANG/LLVM when compiling BOOST code.

03 Oct 2014 11:57 - John Abbott

Status: Closed Start date: 03 Oct 2014

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Portability Estimated time: 0.00 hour

Target version: CoCoA-5.1.3/4 Jan 2016 Spent time: 2.20 hours

Description

Recent MacOSX compilers produce lots of (spurious?) warnings when compiling BOOST code.

The warnings can be suppressed by adding the flag -Wno-c99-extensions to CXXFLAGS_CUSTOM on line 3 of

src/CoCoA-5/Makefile

Related issues:

Related to CoCoALib - Support #1700: boost_1_80_0 Closed 14 Oct 2022

History

#1 - 03 Oct 2014 12:00 - John Abbott

Currently the edit has to be done by hand.

Is it worth trying to add the flag automatically? (e.g. during configuration?)

The BOOST people are aware of the problem; so hopefully they will sort it out (or maybe the CLANG/LLVM people will find a solution)

Perhaps we should add a comment to documentation somewhere; it is quite alarming to see all the warning messages scroll by.

#2 - 03 Oct 2014 12:03 - John Abbott

I have revised some impls in CoCoALibSupplement.C to avoid some warnings by Clang/LLVM; the problem derived from the fact that the compiler did

not know that CoCoA_ERROR does not return.

In some ways the new code might even be more readable than the old.  Anyway, all tests pass, and I have checked in.

#3 - 29 Jul 2015 15:49 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- Target version changed from CoCoA-5.1.2 summer 2015 to CoCoA-5.1.3/4 Jan 2016

- % Done changed from 0 to 50

Is this really our problem?  Morally speaking, I'd say not; in practice, it is.

I have added a note to the installation instructions (i.e. doc/txt/INSTALL.txt and doc/html/INSTALL.html) saying that compiler warnings should just be

ignored.

I'm not sure whether the workaround suggested in the description is worth implementing... after all, if the BOOST people and the llvm people can

come to an amicable agreement then the issue should simply go away... (it is really their problem).
#4 - 15 Aug 2015 21:39 - John Abbott

This issue was originally raised by Laura Torrente (on 2 Oct 2014, via email).

#5 - 18 Feb 2016 15:31 - John Abbott

- Status changed from In Progress to Closed

- Target version changed from CoCoA-5.1.3/4 Jan 2016 to CoCoA-5.?.?

- % Done changed from 50 to 100

Closing this issue because I think we have already done all that is reasonable.  Maybe the problem will go away completely when we switch to

C++11?

#6 - 04 Dec 2017 11:45 - Redmine Admin

- Target version changed from CoCoA-5.?.? to CoCoA-5.1.3/4 Jan 2016

#7 - 14 Oct 2022 16:24 - Anna Maria Bigatti

- Related to Support #1700: boost_1_80_0 added

#8 - 14 Oct 2022 16:25 - Anna Maria Bigatti

- Subject changed from MacOSX: many warnings with compiler CLANG/LLVM to MacOSX: many warnings with compiler CLANG/LLVM when

compiling BOOST code.
